package com.agiledeveloper;

import rx.Observable;
import rx.Subscriber;

import java.util.List;

public class MovieServer {
  public Observable<String> getDirectors(final List<String> movieNames) {
    return Observable.create(
        new Observable.OnSubscribe<String>() {
          @Override
          public void call(Subscriber<? super String> subscriber) {
            for (String movieName : movieNames) {
              if (subscriber.isUnsubscribed()) {
                System.out.println("not sending anymore");
                return;
              }

              System.out.println("Checking info for movie " + movieName);
              String director = MovieInfo.getMovieInfo(movieName).get("Director");
              subscriber.onNext(movieName + "---" + director);
            }

            subscriber.onCompleted();
          }
        });
  }
}